
import jalview.bin.Jalview
import jalview.io.gff.GffConstants;
import jalview.workers.AnnotationProviderI
import jalview.workers.AlignmentAnnotationFactory
import jalview.datamodel.*;
  
/*
 * Define something that counts each visible feature type
 */
def sdppredCounter =
    [
     getNames: { visibleFeatures as String[] }, 
     getDescriptions:  { visibleFeatures as String[] },
     getMinColour: { [0, 255, 255] as int[] }, // cyan
     getMaxColour: { [0, 0, 255] as int[] }, // blue
     count: 
         { res, feats -> 
             getCounts.call(feats) 
         },
     calculateAnnotation: 
         { al, feat_rend ->         
         ProfilesI a_prof=al.getSequenceConsensusHash();
         al_width = a_prof.getEndColumn();
//         jalview.datamodel.Annotation ai[] = new jalview.datamodel.Annotation[al_width];
         def sg_profs = [];
         al.getGroups().each({group -> sg_profs << group.getSequenceConsensusHash() });
         if (sg_profs==null) {
           return null;
         }
         annot = new Annotation[al_width];
         for (int c=0;c<al_width;c++) {
           def al_p=a_prof.get(c);
           if (al_p!=null) {
           def al_ng = al_p.getNonGapped()
           if (al_p.getCounts()!=null) {
           al_p = al_p.getCounts().getSymbolCounts();
           def tot_count=[foo:0];
           for (int a=al_p.values.length-1;a>-1;a--) {
             tot_count << [(al_p.symbols[a]):(al_p.values[a])]
           }
           Ip=0.0;
           if (al_ng>0) {
             sg_profs.each({sg_prof -> 
               if (sg_prof!=null) {count = sg_prof.get(c);
               if ((count!=null) && (count.getCounts()!=null)) {
                 g_size = count.getHeight();
                 count = count.getCounts().getSymbolCounts(); 
                 for (int a=count.values.length-1;a>-1; a--) {
                   Ip+= (count.values[a]/al_ng) * Math.log((count.values[a]*al_ng)/(g_size*tot_count[(count.symbols[a])]));
                 }
               }
               }
             });
           annot[c]=new Annotation((float) Ip);

           }
         }
         }
         }
         AlignmentAnnotation annotrow = new AlignmentAnnotation("SDPpred","SDP calculation results",annot);
         annotrow.setCalcId("SDPPRED");
         return [annotrow];
     }
     ] as AnnotationProviderI

/*
 * and register the counter
 */
AlignmentAnnotationFactory.newCalculator(sdppredCounter)
